var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as PropTypes from "prop-types";
import * as React from "react";
import * as classnames from "classnames";
import Tooltip from "../Tooltip";
import Arrow from "./Arrow";
import "./NavLink.less";
var propTypes = {
    className: PropTypes.string,
    component: PropTypes.any,
    href: PropTypes.string,
    icon: PropTypes.element,
    label: PropTypes.node,
    title: PropTypes.string,
    onClick: PropTypes.func,
    selected: PropTypes.bool,
    // Internal use only:
    _collapsed: PropTypes.bool,
    _withArrow: PropTypes.bool,
    _withTooltips: PropTypes.bool,
};
export var cssClass = {
    ARROW_CONTAINER: "NavLink--arrow--container",
    ARROW_ICON: "NavLink--arrow",
    COLLAPSED: "NavLink--collapsed",
    CONTAINER: "NavLink",
    CONTENTS: "NavLink--contents",
    ICON: "NavLink--icon",
    ICON_CONTAINER: "NavLink--icon--container",
    LABEL: "NavLink--label",
    LABEL_CONTAINER: "NavLink--label--container",
    SELECTED: "NavLink--selected",
    WITH_ARROW: "NavLink--withArrow",
};
var NavLink = /** @class */ (function (_super) {
    __extends(NavLink, _super);
    function NavLink() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NavLink.prototype.render = function () {
        var _a = this.props, _collapsed = _a._collapsed, _withArrow = _a._withArrow, _withTooltips = _a._withTooltips, className = _a.className, component = _a.component, href = _a.href, icon = _a.icon, label = _a.label, title = _a.title, onClick = _a.onClick, selected = _a.selected, additionalProps = __rest(_a, ["_collapsed", "_withArrow", "_withTooltips", "className", "component", "href", "icon", "label", "title", "onClick", "selected"]);
        var Component = "button";
        if (component) {
            Component = component;
        }
        else if (href) {
            Component = "a";
        }
        var element = (React.createElement(Component, __assign({}, additionalProps, { className: classnames(cssClass.CONTAINER, selected && cssClass.SELECTED, _collapsed && cssClass.COLLAPSED, _withArrow && cssClass.WITH_ARROW, className), href: href, onClick: onClick }),
            React.createElement("div", { className: cssClass.CONTENTS },
                icon && (React.createElement("div", { className: cssClass.ICON_CONTAINER }, React.cloneElement(icon, {
                    className: classnames(cssClass.ICON, icon.props.className),
                }))),
                React.createElement("div", { className: cssClass.LABEL_CONTAINER },
                    React.createElement("div", { className: cssClass.LABEL, title: (title || label) }, label)),
                _withArrow && (React.createElement("div", { className: cssClass.ARROW_CONTAINER },
                    React.createElement(Arrow, { className: cssClass.ARROW_ICON }))))));
        if (!_withTooltips) {
            return element;
        }
        return (React.createElement(Tooltip, { content: label, hide: !_collapsed, placement: Tooltip.Placement.RIGHT }, element));
    };
    NavLink.propTypes = propTypes;
    return NavLink;
}(React.PureComponent));
export { NavLink };
